var five = require("../lib/johnny-five.js");
var temporal = require("temporal");
var board = new five.Board({ port: "/dev/cu.usbmodem1421" });
// var board = new five.Board();
//
//
//

// TODO:

// - Work through all items in Step 17:
//   http://www.lynxmotion.com/images/html/build106.htm
//
// - Gait:
// Step 1 Shift weight to robot's right
// Step 2  Step forward
// Step 3  Shift weight to robot's left
// Step 4  Step forward
//

// rh  -25
// lh   25
// rk  -20
// lk   20
// rf   -8
// lf    8
//
// Then reverse.






board.on("ready", function() {
  var all, hips, knees, feet, task;
  var isStopped = false;
  var legs = {};
  var inits = [
    { pin: 11, id: "rh", startAt: 90 },
    { pin: 10, id: "lh", startAt: 85, isInverted: true },
    { pin: 9,  id: "rk", startAt: 90 },
    { pin: 6,  id: "lk", startAt: 90, isInverted: true },
    { pin: 5,  id: "rf", startAt: 90 },
    { pin: 3,  id: "lf", startAt: 90, isInverted: true }

    // { pin: 11, id: "rh", startAt: 120 },
    // { pin: 10, id: "lh", startAt: 120, isInverted: true },
    // { pin: 9,  id: "rk", startAt: 120 },
    // { pin: 8,  id: "lk", startAt: 120, isInverted: true },
    // { pin: 7,  id: "rf", startAt: 90  },
    // { pin: 6,  id: "lf", startAt: 90,  isInverted: true }
  ];

  var neck = new five.Servo({ pin: 7, range: [45, 135], startAt: 90 });
  var eyes = new five.IR.Distance({
    device: "2Y0A21",
    pin: "A0",
    freq: 500
  });

  var state = {
    isStopped: false,
    command: "fwd",
  };

  // Leg initialization
  legs = inits.reduce(function(accum, init) {
    accum[init.id] = new five.Servo(init);
    return accum;
  }, {});

  // Groupings
  all = new five.Servos();
  hips = new five.Servos([ legs.rh, legs.lh ]);
  knees = new five.Servos([ legs.rk, legs.lk ]);
  feet = new five.Servos([ legs.rf, legs.lf ]);

  function move(positions, speed) {
    [ "rf", "rk", "rh", "lf", "lk", "lh" ].forEach(function(part, i) {
      legs[part].to(positions[i], speed);
    });
  }

  function step(positions, speed) {
    [ "rf", "rk", "rh", "lf", "lk", "lh" ].forEach(function(part, i) {
      legs[part].step(positions[i], speed);
    });
  }

  function Gait(sequences) {
    Array.call(this);

    sequences.forEach(function(sequence, i) {
      this.push({
        wait: 500,
        task: function() {
          move(sequence, 500);
        }
      });
    }, this);
  }

  Gait.prototype = Object.create(Array.prototype, {
    constructor: {
      value: Gait
    }
  });

    // var gait = new Gait([
    //   [ 97, 70, 70, 83, 110, 110 ],
    //   [ 83, 70, 70, 97, 110, 110 ],
    //   [ 83, 110, 110, 97, 70, 70 ],
    //   [ 97, 110, 110, 83, 70, 70 ]
    // ]);

    // console.log( gait );

  var gaits = [
    {
      id: "fwd",
      sets: [
        {
          id: "m",
          lapse: 500,
          sequence: [
          // [  rf,  rk,  rh,  lf,  lk,  lh ]
            [ 105, 70, 70, 75, 110, 110 ],
            [ 75, 70, 70, 105, 110, 110 ],
            [ 75, 110, 110, 105, 70, 70 ],
            [ 105, 110, 110, 75, 70, 70 ]
          ]
        },
        {
          id: "l",
          lapse: 600,
          sequence: [
          // [  rf,  rk,  rh,  lf,  lk,  lh ]
            [ 105,  45,  45,  70, 135, 135 ],
            [  78,  45,  45, 102, 135, 135 ],
            [  78, 135, 135, 102,  45,  45 ],
            [ 105, 135, 135,  70,  45,  45 ]
          ]
        }
      ]
    }
  ];

  var controls = gaits.reduce(function(controls, gait) {
    controls[gait.id] = gait.sets.reduce(function(seq, set) {
      seq[set.id] = function() {
        var queue = set.sequence.map(function(sequence) {
          return {
            wait: set.lapse,
            task: function() {
              move(sequence, set.lapse);
            }
          }
        });

        queue.push({
          wait: 10,
          task: controls[gait.id][set.id]
        });

        task = temporal.queue(queue);
      };

      return seq;
    }, {});

    return controls;
  }, {});


  //   fwd: function() {
  //     var queue = [
  //     // [  rf,  rk,  rh,  lf,  lk,  lh ]
  //       // [  97, 70, 70, 83, 110, 110 ],
  //       // [ 83, 70, 70,  97, 110, 110 ],
  //       // [ 83, 110, 110,  97, 70, 70 ],
  //       // [  97, 110, 110, 83, 70, 70 ]
  //       [ 105, 70, 70, 75, 110, 110 ],
  //       [ 75, 70, 70, 105, 110, 110 ],
  //       [ 75, 110, 110, 105, 70, 70 ],
  //       [ 105, 110, 110, 75, 70, 70 ]
  //     ].map(function(sequence) {
  //       return {
  //         wait: 500,
  //         task: function() {
  //           move(sequence, 500);
  //         }
  //       }
  //     });

  //     queue.push({
  //       wait: 100,
  //       task: control.fwd
  //     });

  //     task = temporal.queue(queue);
  //   },

  //   fwdlong: function() {
  //     var queue = [
  //     // [  rf,  rk,  rh,  lf,  lk,  lh ]
  //       [ 105,  45,  45,  70, 135, 135 ],
  //       [  78,  45,  45, 102, 135, 135 ],
  //       [  78, 135, 135, 102,  45,  45 ],
  //       [ 105, 135, 135,  70,  45,  45 ]

  //     ].map(function(sequence) {
  //       return {
  //         wait: 600,
  //         task: function() {
  //           move(sequence, 600);
  //         }
  //       }
  //     });

  //     queue.push({
  //       wait: 100,
  //       task: control.fwdlong
  //     });

  //     task = temporal.queue(queue);
  //   }
  // };

  function scan() {
    var direction = 1;

    task = temporal.loop(750, function() {
      neck.to(neck.range[(direction ^= 0x01)], 750);
    });
  }

  eyes.on("data", function() {
    var heading, direction;

    if (this.inches < 5) {
      // Brat has already stopped, do nothing.
      if (isStopped) {
        return;
      }

      heading = neck.last.degrees;

      if (heading < 90) {
        direction = "left";
      } else {
        direction = "right";
      }

      if (heading < 110 && heading > 80) {
        direction = "forward";
      }

      console.log("danger close: %s", direction);

      if (task) {
        isStopped = true;
        task.stop();
      }
    } else {
      if (isStopped) {
        isStopped = false;
        // Need state of last direction here.
        fwd();
      }
    }
  });

  this.repl.inject({
    get task() {
      return task;
    },
    neck: neck,
    all: all,
    hips: hips,
    knees: knees,
    feet: feet,
    legs: legs,
    controls: controls,
    // fwd: fwd,
    // fwdlong: fwdlong,
    scan: scan,
    eyes: eyes,
    peanuts: function() {
      var direction = 0;

      task = temporal.loop(500, function() {

        if (direction) {
          feet.to(150, 500);
        } else {
          feet.to(90, 500);
        }

        direction = direction ? 0 : 1;
      });
    }
  });

  // fwd();
});
